
// -------------------------------------------------------------
// Filter Settings:
// 	Filter Structure  : serial
// 	Filter Length     : 21
// 	Input             : s8,7
// 	Coefficients      : s8,7
//  	Output            : s19,14
//  	Product           : s15,14
//   	Accumulator       : s19,14
// 	TargetLanguage    : Verilog
// 	FIRAdderStyle     : Normal
// 	PipelineRegisters : False
// 	MultiplyType      : normal
// 	Partition         : [4, 4, 4, 3, 3, 3]
// 	InRegister        : False
// 	OutRegister       : True
// Synthesis Result :
//  	Min Time          : [6.4400000000000013, 27489.0, 0.065867600000000012]
//  	Min Time Path     : ['Dly011', 'Mux000', 'Mul000', 'Add002', 'Add003', 'Par_ADD', 'Mux008']
//   	Max Time          : [33.340000000000003, 8169.0, 0.0014340360000000001]
//  	Max Time Path     : ['Dly011', 'Mux000', 'Mul000', 'Add002', 'Add003', 'Par_ADD', 'Mux008']
// -------------------------------------------------------------
// -------------------------------------------------------------
// HDL Code Generation Options:
// 	Module Name       : filter_serial_21_4
// 	ResetType         : syncronous
// 	Edge              : posedge
// -------------------------------------------------------------
module   filter_serial_21_4 (  reset, filter_out, clk_enable, filter_in, clk );
		 input  reset; // u1_0
		 output [18:0] filter_out; // s19_14
		 input  clk_enable; // u1_0
		 input [7:0] filter_in; // s8_7
		 input  clk; // u1_0

// Constants
	parameter signed [7:0] Coe001= 8'b00000000; //s8_7 //0.0
	parameter signed [7:0] Coe002= 8'b11111111; //s8_7 //-0.0078125
	parameter signed [7:0] Coe003= 8'b00000000; //s8_7 //0.0
	parameter signed [7:0] Coe004= 8'b00000001; //s8_7 //0.0078125
	parameter signed [7:0] Coe005= 8'b00000010; //s8_7 //0.015625
	parameter signed [7:0] Coe006= 8'b11111111; //s8_7 //-0.0078125
	parameter signed [7:0] Coe007= 8'b11111011; //s8_7 //-0.0390625
	parameter signed [7:0] Coe008= 8'b11111101; //s8_7 //-0.0234375
	parameter signed [7:0] Coe009= 8'b00001000; //s8_7 //0.0625
	parameter signed [7:0] Coe010= 8'b00010110; //s8_7 //0.171875
	parameter signed [7:0] Coe011= 8'b00011111; //s8_7 //0.2421875
	parameter signed [7:0] Coe012= 8'b00010110; //s8_7 //0.171875
	parameter signed [7:0] Coe013= 8'b00001000; //s8_7 //0.0625
	parameter signed [7:0] Coe014= 8'b11111101; //s8_7 //-0.0234375
	parameter signed [7:0] Coe015= 8'b11111011; //s8_7 //-0.0390625
	parameter signed [7:0] Coe016= 8'b11111111; //s8_7 //-0.0078125
	parameter signed [7:0] Coe017= 8'b00000010; //s8_7 //0.015625
	parameter signed [7:0] Coe018= 8'b00000001; //s8_7 //0.0078125
	parameter signed [7:0] Coe019= 8'b00000000; //s8_7 //0.0
	parameter signed [7:0] Coe020= 8'b11111111; //s8_7 //-0.0078125
	parameter signed [7:0] Coe021= 8'b00000000; //s8_7 //0.0
	parameter signed [7:0] CoeZ= 8'b00000000; //s8_7 //0.0

// Signals defination
	wire signed [18:0] Add000; //s19_14
	wire signed [19:0] Add000_t; //s20_14
	wire signed [18:0] Add000_t1; //s19_14
	wire signed [18:0] Add000_t2; //s19_14
	wire signed [18:0] Add002; //s19_14
	wire signed [19:0] Add002_t; //s20_14
	wire signed [18:0] Add002_t1; //s19_14
	wire signed [18:0] Add002_t2; //s19_14
	wire signed [18:0] Add003; //s19_14
	wire signed [19:0] Add003_t; //s20_14
	wire signed [18:0] Add003_t1; //s19_14
	wire signed [18:0] Add003_t2; //s19_14
	wire signed [14:0] Mul000; //s15_14
	wire signed [15:0] Mul000_t; //s16_14
	wire signed [14:0] Mul001; //s15_14
	wire signed [15:0] Mul001_t; //s16_14
	wire signed [14:0] Mul002; //s15_14
	wire signed [15:0] Mul002_t; //s16_14
	wire signed [14:0] Mul003; //s15_14
	wire signed [15:0] Mul003_t; //s16_14
	wire signed [7:0] Mux000; //s8_7
	wire signed [7:0] Mux001; //s8_7
	wire signed [7:0] Mux002; //s8_7
	wire signed [7:0] Mux003; //s8_7
	wire signed [7:0] Mux004; //s8_7
	wire signed [7:0] Mux005; //s8_7
	wire signed [7:0] Mux006; //s8_7
	wire signed [7:0] Mux007; //s8_7
	wire signed [18:0] Mux008; //s19_14
	wire signed [18:0] Par_ADD; //s19_14
	wire signed [19:0] Par_ADD_t; //s20_14
	wire signed [18:0] Par_ADD_t1; //s19_14
	wire signed [18:0] Par_ADD_t2; //s19_14
	wire    Phs001; // 1_0
	wire    PhsZ; // 1_0
	wire signed [18:0] filter_out; //s19_14
	reg signed [18:0] Acc000; //s19_14
	reg   [2:0] Ctr000; // 3_0
	reg signed [7:0] Dly000; //s8_7
	reg signed [7:0] Dly001; //s8_7
	reg signed [7:0] Dly002; //s8_7
	reg signed [7:0] Dly003; //s8_7
	reg signed [7:0] Dly004; //s8_7
	reg signed [7:0] Dly005; //s8_7
	reg signed [7:0] Dly006; //s8_7
	reg signed [7:0] Dly007; //s8_7
	reg signed [7:0] Dly008; //s8_7
	reg signed [7:0] Dly009; //s8_7
	reg signed [7:0] Dly010; //s8_7
	reg signed [7:0] Dly011; //s8_7
	reg signed [7:0] Dly012; //s8_7
	reg signed [7:0] Dly013; //s8_7
	reg signed [7:0] Dly014; //s8_7
	reg signed [7:0] Dly015; //s8_7
	reg signed [7:0] Dly016; //s8_7
	reg signed [7:0] Dly017; //s8_7
	reg signed [7:0] Dly018; //s8_7
	reg signed [7:0] Dly019; //s8_7
	reg signed [18:0] Dly020; //s19_14
	reg signed [18:0] Dly021; //s19_14

//Statements
//Level = 0
// Delay Block Statement
	always @ ( posedge clk)
	begin
		if (reset == 1'b1) begin
			Dly000 <= 8'b00000000 ;
			Dly001 <= 8'b00000000 ;
			Dly002 <= 8'b00000000 ;
			Dly003 <= 8'b00000000 ;
			Dly004 <= 8'b00000000 ;
			Dly005 <= 8'b00000000 ;
			Dly006 <= 8'b00000000 ;
			Dly007 <= 8'b00000000 ;
			Dly008 <= 8'b00000000 ;
			Dly009 <= 8'b00000000 ;
			Dly010 <= 8'b00000000 ;
			Dly011 <= 8'b00000000 ;
			Dly012 <= 8'b00000000 ;
			Dly013 <= 8'b00000000 ;
			Dly014 <= 8'b00000000 ;
			Dly015 <= 8'b00000000 ;
			Dly016 <= 8'b00000000 ;
			Dly017 <= 8'b00000000 ;
			Dly018 <= 8'b00000000 ;
			Dly019 <= 8'b00000000 ;
		end
		else begin
			if (clk_enable == 1'b1) begin
				if ( PhsZ == 1'b1)
				begin
					Dly000 <= filter_in;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly001 <= Dly000;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly002 <= Dly001;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly003 <= Dly002;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly004 <= Dly003;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly005 <= Dly004;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly006 <= Dly005;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly007 <= Dly006;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly008 <= Dly007;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly009 <= Dly008;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly010 <= Dly009;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly011 <= Dly010;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly012 <= Dly011;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly013 <= Dly012;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly014 <= Dly013;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly015 <= Dly014;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly016 <= Dly015;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly017 <= Dly016;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly018 <= Dly017;
				end
				if ( PhsZ == 1'b1)
				begin
					Dly019 <= Dly018;
				end
			end
		end
	end
	always @ (posedge clk)
	begin
		if (reset == 1'b1) begin
			Ctr000 <= 3'b101;
		end
		else begin
			if (clk_enable == 1'b1) begin
				if( Ctr000 == 3'b101)begin
					Ctr000 <= 3'b000;
				end
				else begin
					Ctr000 <= Ctr000 + 1;
				end
			end
		end
	end
//Level = 1
	assign PhsZ = (Ctr000 == 3'b101  && clk_enable == 1'b1)? 1 : 0 ;
	assign Phs001 = (Ctr000 == 3'b000  && clk_enable == 1'b1)? 1 : 0 ;
	assign Mux000 = (Ctr000 == 3'b000) ? filter_in :  (Ctr000 == 3'b001) ? Dly003 :  (Ctr000 == 3'b010) ? Dly007 :  (Ctr000 == 3'b011) ? Dly011 :  (Ctr000 == 3'b100) ? Dly014 : Dly017 ;
	assign Mux001 = (Ctr000 == 3'b000) ? Coe001 :  (Ctr000 == 3'b001) ? Coe005 :  (Ctr000 == 3'b010) ? Coe009 :  (Ctr000 == 3'b011) ? Coe013 :  (Ctr000 == 3'b100) ? Coe016 : Coe019 ;
	assign Mux002 = (Ctr000 == 3'b000) ? Dly000 :  (Ctr000 == 3'b001) ? Dly004 :  (Ctr000 == 3'b010) ? Dly008 :  (Ctr000 == 3'b011) ? Dly012 :  (Ctr000 == 3'b100) ? Dly015 : Dly018 ;
	assign Mux003 = (Ctr000 == 3'b000) ? Coe002 :  (Ctr000 == 3'b001) ? Coe006 :  (Ctr000 == 3'b010) ? Coe010 :  (Ctr000 == 3'b011) ? Coe014 :  (Ctr000 == 3'b100) ? Coe017 : Coe020 ;
	assign Mux004 = (Ctr000 == 3'b000) ? Dly001 :  (Ctr000 == 3'b001) ? Dly005 :  (Ctr000 == 3'b010) ? Dly009 :  (Ctr000 == 3'b011) ? Dly013 :  (Ctr000 == 3'b100) ? Dly016 : Dly019 ;
	assign Mux005 = (Ctr000 == 3'b000) ? Coe003 :  (Ctr000 == 3'b001) ? Coe007 :  (Ctr000 == 3'b010) ? Coe011 :  (Ctr000 == 3'b011) ? Coe015 :  (Ctr000 == 3'b100) ? Coe018 : Coe021 ;
	assign Mux006 = (Ctr000 == 3'b000) ? Dly002 :  (Ctr000 == 3'b001) ? Dly006 :  (Ctr000 == 3'b010) ? Dly010 :  (Ctr000 == 3'b011) ? Dly013 :  (Ctr000 == 3'b100) ? Dly016 : Dly019 ;
	assign Mux007 = (Ctr000 == 3'b000) ? Coe004 :  (Ctr000 == 3'b001) ? Coe008 :  (Ctr000 == 3'b010) ? Coe012 :  (Ctr000 == 3'b011) ? CoeZ :  (Ctr000 == 3'b100) ? CoeZ : CoeZ ;
//Level = 2
	assign Mul000_t = Mux001 * Mux000 ;
	assign Mul000 = $signed({Mul000_t[14:0]});

	assign Mul001_t = Mux003 * Mux002 ;
	assign Mul001 = $signed({Mul001_t[14:0]});

	assign Mul002_t = Mux005 * Mux004 ;
	assign Mul002 = $signed({Mul002_t[14:0]});

	assign Mul003_t = Mux007 * Mux006 ;
	assign Mul003 = $signed({Mul003_t[14:0]});

//Level = 3
	assign Par_ADD_t1 = Add003;
	assign Par_ADD_t2 = $signed({{4{Mul003[14]}} ,Mul003[14:0]});
	assign Par_ADD_t = Par_ADD_t1 + Par_ADD_t2 ;
	assign Par_ADD = $signed({Par_ADD_t[18:0]});

	assign Add002_t1 = $signed({{4{Mul000[14]}} ,Mul000[14:0]});
	assign Add002_t2 = $signed({{4{Mul001[14]}} ,Mul001[14:0]});
	assign Add002_t = Add002_t1 + Add002_t2 ;
	assign Add002 = $signed({Add002_t[18:0]});

	assign Add003_t1 = Add002;
	assign Add003_t2 = $signed({{4{Mul002[14]}} ,Mul002[14:0]});
	assign Add003_t = Add003_t1 + Add003_t2 ;
	assign Add003 = $signed({Add003_t[18:0]});

//Level = 4
	assign Add000_t1 = Par_ADD;
	assign Add000_t2 = Dly020;
	assign Add000_t = Add000_t1 + Add000_t2 ;
	assign Add000 = $signed({Add000_t[18:0]});

//Level = 5
// Delay Block Statement
	always @ ( posedge clk)
	begin
		if (reset == 1'b1) begin
			Dly020 <= 19'b0000000000000000000 ;
		end
		else begin
			if (clk_enable == 1'b1) begin
				Dly020 <= Mux008;
			end
		end
	end
	assign Mux008 = (Phs001 == 1'b0) ? Add000 : Par_ADD ;
//Level = 6
// Delay Block Statement
	always @ ( posedge clk)
	begin
		if (reset == 1'b1) begin
			Dly021 <= 19'b0000000000000000000 ;
		end
		else begin
			if (clk_enable == 1'b1) begin
				Dly021 <= Acc000;
			end
		end
	end
// Accumulater
	always @ ( posedge clk)
	begin
		if (reset == 1'b1) begin
			Acc000 <= 19'b0000000000000000000 ;
		end
		else begin
			if (clk_enable == 1'b1) begin
				if ( PhsZ == 1'b1)
				begin
					Acc000 <= Mux008;
				end
			end
		end
	end
//Level = 7
	assign filter_out = Dly021;
endmodule
